import glob
import csv
import numpy as np

# Oppgi sti hvor mappen Programmering ligger lagret
sti = 'C:\\Programmering\\'

# Filer som skal analyseres
innSti = sti + 'Friksjonsmålinger\\Renset\\*'
utSti = sti + 'Python\\BruMatrise.npy'
filListe = glob.glob(innSti)

# Lister som holder verider
dagListe = []
maanedListe = []
aarListe = []
klokkeslettListe = []
filnavnListe = []
utstyrListe = []
fylkeListe = []
vegListe = []
friksjonListe = []
luftTemperaturListe = []
vegTemperaturListe = []
fuktListe = []
bruIDListe = []
bruTypeListe = []
bruMaterialeListe = []
bruLengdeListe = []
bruAarListe = []
avstandListe = []
driftsklasseListe = []
radiusListe = []

for fil in filListe:
    linjeTeller = -1
    with open(fil, 'r', encoding='utf-8') as originalFil:
        for linje in originalFil:  # Henter interesant informasjon fra filenes metada
            linjeTeller = linjeTeller + 1
            if linjeTeller == 0:
                dag = linje[6:8]
                maaned = linje[9:11]
                aar = linje[12:16]
                klokkeslett = linje[17:22]
            if linjeTeller == 3:
                filnavn = linje[9:].strip()
            if linjeTeller == 10:
                utstyr = linje[8:].strip()
            if linjeTeller == 16:
                fylke = linje[7:].strip()
            if linjeTeller == 17:
                veg = linje[5:].strip()
            if linjeTeller == 18:
                break
        originalFil.seek(0)  # Går til starten av filen igjen

        aktivFil_reader = csv.reader(originalFil, delimiter='\t')
        for i in range(30):  # Bruker for-løkken til å hoppe over de første 30 linjene med metadata
            next(aktivFil_reader)
        for linje in aktivFil_reader:  # Henter ut interessant data
            friksjon = float(linje[3])
            luftTemperatur = float(linje[5])
            vegTemperatur = float(linje[6])
            fukt = linje[7]
            bruID = linje[15]
            bruType = linje[16]
            bruMateriale = linje[17]
            bruLengde = linje[18]
            bruAar = linje[19]
            avstand = float(linje[20])
            driftsklasse = linje[21]
            radius = linje[22]
            if bruID != 'None' and friksjon != -1 and avstand <= 100 and (luftTemperatur <= 1 or vegTemperatur <= 1):  # Legger til data dersom friksjonen og avstanden er gyldig, samt temperatur lavere enn 1 grad celsisus
                dagListe.append(dag)
                maanedListe.append(maaned)
                aarListe.append(aar)
                klokkeslettListe.append(klokkeslett)
                filnavnListe.append(filnavn)
                utstyrListe.append(utstyr)
                fylkeListe.append(fylke)
                vegListe.append(veg)
                friksjonListe.append(friksjon)
                luftTemperaturListe.append(luftTemperatur)
                vegTemperaturListe.append(vegTemperatur)
                fuktListe.append(fukt)
                bruIDListe.append(bruID)
                bruTypeListe.append(bruType)
                bruMaterialeListe.append(bruMateriale)
                bruLengdeListe.append(bruLengde)
                bruAarListe.append(bruAar)
                avstandListe.append(avstand)
                driftsklasseListe.append(driftsklasse)
                radiusListe.append(radius)

matrise = np.array([filnavnListe, bruIDListe, avstandListe, friksjonListe, driftsklasseListe, luftTemperaturListe,  # samler listene i en matrise
                    vegTemperaturListe, fuktListe, bruTypeListe, bruMaterialeListe, bruLengdeListe, bruAarListe,
                    radiusListe, utstyrListe, vegListe, fylkeListe, aarListe, maanedListe, dagListe, klokkeslettListe])
np.save(utSti, np.transpose(matrise))
