import math
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec
import matplotlib.ticker as ticker

vegklasse = 'H1'
fartsgrense = 80
fartstillegg = 5
overhoyde = 8  # I prosent
totalfriksjon = 0.461
sidefriksjonsandel = 34  # I prosent
sikkerhetsfaktor = 1

minsteHorisontalkurveradius = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(totalfriksjon*(sidefriksjonsandel/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradius50 = minsteHorisontalkurveradius * 1.5

sidefriksjonNorge = 0.157
sidefriksjonSverige = 0.13
sidefriksjonDanmark = sidefriksjonSverige
sidefriksjonUSA = 0.14
sidefriksjonCanada = 0.14
sidefriksjonAustralia = 0.16
sidefriksjonMontana = 0.14


def nedrunding(tall, base=25):
    return base * math.floor(tall/base)


def opprunding(tall, base=25):
    return base * math.ceil(tall/base)


# Totalfriksjon
totalfriksjonIntervall = np.arange(0, 1.01, 0.01)
totalfriksjonXverdier = []
totalfriksjonYverdierP4 = []
totalfriksjonYverdierP2 = []
totalfriksjonYverdierN0 = []
totalfriksjonYverdierM2 = []
totalfriksjonYverdierM4 = []

minsteHorisontalkurveradiusP4 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(totalfriksjon*((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusP2 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(totalfriksjon*((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusN0 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(totalfriksjon*((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM2 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(totalfriksjon*((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM4 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(totalfriksjon*((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

minsteHorisontalkurveradiusP4_015 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.15*((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusP2_015 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.15*((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusN0_015 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.15*((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM2_015 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.15*((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM4_015 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.15*((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

minsteHorisontalkurveradiusP4_018 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.18*((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusP2_018 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.18*((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusN0_018 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.18*((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM2_018 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.18*((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM4_018 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.18*((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

minsteHorisontalkurveradiusP4_020 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.20*((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusP2_020 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.20*((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusN0_020 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.20*((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM2_020 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.20*((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM4_020 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.20*((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

minsteHorisontalkurveradiusP4_023 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.23*((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusP2_023 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.23*((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusN0_023 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.23*((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM2_023 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.23*((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM4_023 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.23*((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

minsteHorisontalkurveradiusP4_030 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.30*((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusP2_030 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.30*((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusN0_030 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.30*((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM2_030 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.30*((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
minsteHorisontalkurveradiusM4_030 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.30*((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

totalfriksjonXverdiP4 = (((fartsgrense + fartstillegg)**2) / (minsteHorisontalkurveradiusP4 * 127) - (overhoyde/100)) / ((sidefriksjonsandel+4)/100)/sikkerhetsfaktor
totalfriksjonXverdiP2 = (((fartsgrense + fartstillegg)**2) / (minsteHorisontalkurveradiusP2 * 127) - (overhoyde/100)) / ((sidefriksjonsandel+2)/100)/sikkerhetsfaktor
totalfriksjonXverdiN0 = (((fartsgrense + fartstillegg)**2) / (minsteHorisontalkurveradiusN0 * 127) - (overhoyde/100)) / ((sidefriksjonsandel+0)/100)/sikkerhetsfaktor
totalfriksjonXverdiM2 = (((fartsgrense + fartstillegg)**2) / (minsteHorisontalkurveradiusM2 * 127) - (overhoyde/100)) / ((sidefriksjonsandel-2)/100)/sikkerhetsfaktor
totalfriksjonXverdiM4 = (((fartsgrense + fartstillegg)**2) / (minsteHorisontalkurveradiusM4 * 127) - (overhoyde/100)) / ((sidefriksjonsandel-4)/100)/sikkerhetsfaktor

for i in totalfriksjonIntervall:
    totalfriksjonXverdier.append(i)
    minsteHorisontalkurveradiusTotalfriksjonP4 = ((fartsgrense + fartstillegg) ** 2) / (127 * ((overhoyde/100) + (i * ((sidefriksjonsandel+4)/100)/sikkerhetsfaktor)))
    minsteHorisontalkurveradiusTotalfriksjonP2 = ((fartsgrense + fartstillegg) ** 2) / (127 * ((overhoyde/100) + (i * ((sidefriksjonsandel+2)/100)/sikkerhetsfaktor)))
    minsteHorisontalkurveradiusTotalfriksjonN0 = ((fartsgrense + fartstillegg) ** 2) / (127 * ((overhoyde/100) + (i * ((sidefriksjonsandel+0)/100)/sikkerhetsfaktor)))
    minsteHorisontalkurveradiusTotalfriksjonM2 = ((fartsgrense + fartstillegg) ** 2) / (127 * ((overhoyde/100) + (i * ((sidefriksjonsandel-2)/100)/sikkerhetsfaktor)))
    minsteHorisontalkurveradiusTotalfriksjonM4 = ((fartsgrense + fartstillegg) ** 2) / (127 * ((overhoyde/100) + (i * ((sidefriksjonsandel-4)/100)/sikkerhetsfaktor)))

    totalfriksjonYverdierP4.append(minsteHorisontalkurveradiusTotalfriksjonP4)
    totalfriksjonYverdierP2.append(minsteHorisontalkurveradiusTotalfriksjonP2)
    totalfriksjonYverdierN0.append(minsteHorisontalkurveradiusTotalfriksjonN0)
    totalfriksjonYverdierM2.append(minsteHorisontalkurveradiusTotalfriksjonM2)
    totalfriksjonYverdierM4.append(minsteHorisontalkurveradiusTotalfriksjonM4)


# Sidefriksjon
landNavn = ['Norge', 'Sverige', 'Danmark', 'USA', 'Canada', 'Australia']
landFarger = ['red', 'green', 'cyan', 'lime', 'brown', 'orange']
sidefriksjonerLand = [sidefriksjonNorge, sidefriksjonSverige, sidefriksjonDanmark, sidefriksjonUSA, sidefriksjonCanada, sidefriksjonAustralia]
unikeSidefriksjonsverdierLandPosisjoner = [sidefriksjonerLand.index(sidefriksjonLand) for sidefriksjonLand in set(sidefriksjonerLand)]

sidefriksjonerLandUnike = []
sidefriksjonerLandDuplikat = []
landNavnUnike = []
landNavnDuplikat = []
fargerUnike = []
fargerDuplikat = []
for i in range(len(sidefriksjonerLand)):
    if i in unikeSidefriksjonsverdierLandPosisjoner:
        sidefriksjonerLandUnike.append(sidefriksjonerLand[i])
        landNavnUnike.append(landNavn[i])
        fargerUnike.append(landFarger[i])
    else:
        sidefriksjonerLandDuplikat.append(sidefriksjonerLand[i])
        landNavnDuplikat.append(landNavn[i])
        fargerDuplikat.append(landFarger[i])
horisontalkurveradiuserLandUnike = [((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(sidefriksjonLand/sikkerhetsfaktor))) for sidefriksjonLand in sidefriksjonerLandUnike]
horisontalkurveradiuserLandDuplikat = [((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(sidefriksjonLand/sikkerhetsfaktor))) for sidefriksjonLand in sidefriksjonerLandDuplikat]
horisontalkurveradiuserLandUnike50 = [horisontalkurveradiusLand * 1.5 for horisontalkurveradiusLand in horisontalkurveradiuserLandUnike]
horisontalkurveradiuserLandDuplikat50 = [horisontalkurveradiusLand * 1.5 for horisontalkurveradiusLand in horisontalkurveradiuserLandDuplikat]
horisontalkurveradiusMontana = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(sidefriksjonMontana/sikkerhetsfaktor)))
horisontalkurveradiusMontana50 = horisontalkurveradiusMontana * 1.5

sidefriksjonIntervall = np.arange(0, 0.25, 0.01)
sidefriksjonXverdier = []
sidefriksjonYverdier = []
for i in sidefriksjonIntervall:
    minsteHorisontalkurveradiusSidefriksjon = ((fartsgrense + fartstillegg) ** 2) / (127 * ((overhoyde / 100) + (i / sikkerhetsfaktor)))
    sidefriksjonXverdier.append(i)
    sidefriksjonYverdier.append(minsteHorisontalkurveradiusSidefriksjon)
sidefriksjonYverdier50 = [horisontalkurveradius * 1.5 for horisontalkurveradius in sidefriksjonYverdier]


# Overhøyde
overhoydeIntervall = np.arange(-3, 12.1, 0.1)
overhoydeXverdier = []
overhoydeYverdier = []
overhoydeYverdier50 = []
overhoydeYverdiDimensjonerende = ((fartsgrense + fartstillegg)**2)/(127*(overhoyde/100+(totalfriksjon*(sidefriksjonsandel/100)/sikkerhetsfaktor)))
overhoydeYverdiDimensjonerende50 = overhoydeYverdiDimensjonerende * 1.5
beregnetOverhoyde = 0
for i in overhoydeIntervall:
    overhoydeXverdier.append(i)
    minsteHorisontalkurveradiusOverhoyde = ((fartsgrense + fartstillegg)**2)/(127*(i/100+(totalfriksjon*(sidefriksjonsandel/100)/sikkerhetsfaktor)))
    overhoydeYverdier.append(minsteHorisontalkurveradiusOverhoyde)
    overhoydeYverdier50.append(minsteHorisontalkurveradiusOverhoyde*1.5)
if minsteHorisontalkurveradius < 250:
    overhoydeGrenseX = [6.5, overhoyde]
    overhoydeGrenseY = [minsteHorisontalkurveradius, minsteHorisontalkurveradius]
    overhoydeLinjeX = [6.5, 6.5]
    overhoydeLinjeY = [0, minsteHorisontalkurveradius]
else:
    beregnetOverhoyde = 6.5 - ((minsteHorisontalkurveradius - 250) / (1000 - 250) * (6.5 - 1.5))
    overhoydeGrenseX = [beregnetOverhoyde, overhoyde]
    overhoydeGrenseY = [minsteHorisontalkurveradius, minsteHorisontalkurveradius]
    overhoydeLinjeX = [beregnetOverhoyde, beregnetOverhoyde]
    overhoydeLinjeY = [0, minsteHorisontalkurveradius]
if minsteHorisontalkurveradius*1.5 < 250:
    overhoydeGrenseX50 = [6.5, overhoyde]
    overhoydeGrenseY50 = [minsteHorisontalkurveradius, minsteHorisontalkurveradius]
    overhoydeLinjeX50 = [6.5, 6.5]
    overhoydeLinjeY50 = [0, minsteHorisontalkurveradius * 1.5]
else:
    beregnetOverhoyde = 6.5 - ((minsteHorisontalkurveradius*1.5 - 250) / (1000 - 250) * (6.5 - 1.5))
    overhoydeGrenseX50 = [beregnetOverhoyde, overhoyde]
    overhoydeGrenseY50 = [minsteHorisontalkurveradius*1.5, minsteHorisontalkurveradius*1.5]
    overhoydeLinjeX50 = [beregnetOverhoyde, beregnetOverhoyde]
    overhoydeLinjeY50 = [0, minsteHorisontalkurveradius*1.5]

# Tilgjengelig sidefriksjon/totalfriksjon med redusert overhøyde
erfaringsverdiOverhoydeAvvik = 2
sidefriksjonBehov = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius) - 8/100
sidefriksjonBehov50 = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius50) - 8/100
sidefriksjonBehovDrift = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius) - 6.5/100
sidefriksjonBehovDrift50 = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius50) - beregnetOverhoyde/100
sidefriksjonBehovErfaring = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius) - (6.5-erfaringsverdiOverhoydeAvvik)/100
sidefriksjonBehovErfaring50 = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius50) - (beregnetOverhoyde-erfaringsverdiOverhoydeAvvik)/100

sidefriksjonBehovXverdier = []
sidefriksjonBehovYverdier = []
sidefriksjonBehovYverdier50 = []
sidefriksjonBehovIntervall = np.arange(0, 12, 0.01)

for i in sidefriksjonBehovIntervall:
    minsteHorisontalkurveradiusSidefriksjon = ((fartsgrense + fartstillegg)**2)/(127*minsteHorisontalkurveradius) - i/100
    sidefriksjonBehovXverdier.append(i)
    sidefriksjonBehovYverdier.append(minsteHorisontalkurveradiusSidefriksjon)
    minsteHorisontalkurveradiusSidefriksjon50 = ((fartsgrense + fartstillegg) ** 2) / (127 * minsteHorisontalkurveradius50) - i / 100
    sidefriksjonBehovYverdier50.append(minsteHorisontalkurveradiusSidefriksjon50)

totalfriksjonBehov = sidefriksjonBehov / (sidefriksjonsandel/100)
totalfriksjonBehov50 = sidefriksjonBehov50 / (sidefriksjonsandel/100)
totalfriksjonBehovDrift = sidefriksjonBehovDrift / (sidefriksjonsandel/100)
totalfriksjonBehovDrift50 = sidefriksjonBehovDrift50 / (sidefriksjonsandel/100)
totalfriksjonBehovErfaring = sidefriksjonBehovErfaring / (sidefriksjonsandel/100)
totalfriksjonBehovErfaring50 = sidefriksjonBehovErfaring50 / (sidefriksjonsandel/100)
totalfriksjonBehovXverdier = sidefriksjonBehovXverdier
totalfriksjonBehovYverdier = [sidefriksjonBehov / (sidefriksjonsandel/100) for sidefriksjonBehov in sidefriksjonBehovYverdier]
totalfriksjonBehovYverdier50 = [sidefriksjonBehov / (sidefriksjonsandel/100) for sidefriksjonBehov in sidefriksjonBehovYverdier50]


# Sikkerhetsfaktor friksjon
totalfriksjonsverdier5persentil = [totalfriksjon, 0.15, 0.18, 0.20, 0.23, 0.30]
totalfriksjonsverdier15persentil = [0.55, 0.15, 0.23, 0.27, 0.33, 0.35]
totalfriksjonsnavn = ['Krav', 'Rim', 'Klasse C', 'Alle klasser', 'Klasse B, middels', 'Klasse A']
totalfriksjonsfarger = ['red', 'cyan', 'lime', 'green', 'salmon', 'brown']

minsteHorisontalkurveradius15 = ((fartsgrense + fartstillegg)**2)/(127*((overhoyde/100)+(0.55*(sidefriksjonsandel/100))))

sikkerhetsfaktor0461 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-overhoyde/100)/((sidefriksjonsandel/100) * 0.461)
sikkerhetsfaktor015 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-overhoyde/100)/((sidefriksjonsandel/100) * 0.15)
sikkerhetsfaktor018 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-overhoyde/100)/(sidefriksjonsandel/100 * 0.18)
sikkerhetsfaktor020 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-overhoyde/100)/(sidefriksjonsandel/100 * 0.20)
sikkerhetsfaktor023 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-overhoyde/100)/(sidefriksjonsandel/100 * 0.23)
sikkerhetsfaktor030 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-overhoyde/100)/(sidefriksjonsandel/100 * 0.30)
sikkerhetsfaktorerBeregnet5persentil = [sikkerhetsfaktor0461, sikkerhetsfaktor015, sikkerhetsfaktor018,
                                        sikkerhetsfaktor020, sikkerhetsfaktor023, sikkerhetsfaktor030]

sikkerhetsfaktor055_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-overhoyde/100)/((sidefriksjonsandel/100) * 0.55)
sikkerhetsfaktor015_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-overhoyde/100)/((sidefriksjonsandel/100) * 0.15)
sikkerhetsfaktor023_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-overhoyde/100)/((sidefriksjonsandel/100) * 0.23)
sikkerhetsfaktor027_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-overhoyde/100)/((sidefriksjonsandel/100) * 0.27)
sikkerhetsfaktor033_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-overhoyde/100)/((sidefriksjonsandel/100) * 0.33)
sikkerhetsfaktor035_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-overhoyde/100)/((sidefriksjonsandel/100) * 0.35)
sikkerhetsfaktorerBeregnet15persentil = [sikkerhetsfaktor055_15, sikkerhetsfaktor015_15, sikkerhetsfaktor023_15,
                                         sikkerhetsfaktor027_15, sikkerhetsfaktor033_15, sikkerhetsfaktor035_15]

sikkerhetsfaktor0461_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius50))-overhoyde/100)/(sidefriksjonsandel/100 * 0.461)
sikkerhetsfaktor015_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius50))-overhoyde/100)/(sidefriksjonsandel/100 * 0.15)
sikkerhetsfaktor018_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius50))-overhoyde/100)/(sidefriksjonsandel/100 * 0.18)
sikkerhetsfaktor020_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius50))-overhoyde/100)/(sidefriksjonsandel/100 * 0.20)
sikkerhetsfaktor023_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius50))-overhoyde/100)/(sidefriksjonsandel/100 * 0.23)
sikkerhetsfaktor030_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius50))-overhoyde/100)/(sidefriksjonsandel/100 * 0.30)
sikkerhetsfaktorerBeregnet5persentil50 = [sikkerhetsfaktor0461_50, sikkerhetsfaktor015_50, sikkerhetsfaktor018_50,
                                          sikkerhetsfaktor020_50, sikkerhetsfaktor023_50, sikkerhetsfaktor030_50]

sikkerhetsfaktor055_15_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15 * 1.5))-overhoyde/100)/((sidefriksjonsandel/100) * 0.55)
sikkerhetsfaktor015_15_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15 * 1.5))-overhoyde/100)/((sidefriksjonsandel/100) * 0.15)
sikkerhetsfaktor023_15_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15 * 1.5))-overhoyde/100)/((sidefriksjonsandel/100) * 0.23)
sikkerhetsfaktor027_15_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15 * 1.5))-overhoyde/100)/((sidefriksjonsandel/100) * 0.27)
sikkerhetsfaktor033_15_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15 * 1.5))-overhoyde/100)/((sidefriksjonsandel/100) * 0.33)
sikkerhetsfaktor035_15_50 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15 * 1.5))-overhoyde/100)/((sidefriksjonsandel/100) * 0.35)
sikkerhetsfaktorerBeregnet15persentil_50 = [sikkerhetsfaktor055_15_50, sikkerhetsfaktor015_15_50, sikkerhetsfaktor023_15_50,
                                            sikkerhetsfaktor027_15_50, sikkerhetsfaktor033_15_50, sikkerhetsfaktor035_15_50]

sikkerhetsfaktorIntervall = np.arange(0.9, 4.01, 0.01)
sikkerhetsfaktorXverdier = []
sikkerhetsfaktorYverdier = []
sikkerhetsfaktorYverdier50 = []
for i in sikkerhetsfaktorIntervall:
    sikkerhetsfaktorXverdier.append(i)
    totalfriksjonBeregnet = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius))-(overhoyde / 100)) / ((sidefriksjonsandel / 100) * i)
    sikkerhetsfaktorYverdier.append(totalfriksjonBeregnet)
    totalfriksjonBeregnet50 = ((((fartsgrense + fartstillegg) ** 2) / (127 * minsteHorisontalkurveradius50)) - (overhoyde / 100)) / ((sidefriksjonsandel / 100) * i)
    sikkerhetsfaktorYverdier50.append(totalfriksjonBeregnet50)

sikkerhetsfaktorIntervall = np.arange(0.9, 4.01, 0.01)
sikkerhetsfaktorXverdier_15 = []
sikkerhetsfaktorYverdier_15 = []
sikkerhetsfaktorYverdier_15_50 = []

for i in sikkerhetsfaktorIntervall:
    sikkerhetsfaktorXverdier_15.append(i)
    totalfriksjonBeregnet_15 = ((((fartsgrense + fartstillegg)**2)/(127 * minsteHorisontalkurveradius15))-(overhoyde / 100)) / ((sidefriksjonsandel / 100) * i)
    sikkerhetsfaktorYverdier_15.append(totalfriksjonBeregnet_15)
    totalfriksjonBeregnet_15_50 = ((((fartsgrense + fartstillegg) ** 2) / (127 * minsteHorisontalkurveradius15 * 1.5)) - (overhoyde / 100)) / ((sidefriksjonsandel / 100) * i)
    sikkerhetsfaktorYverdier_15_50.append(totalfriksjonBeregnet_15_50)


# lager figurer for henholdsvis totalfriksjon, sidefriksjonsandel, overhøyde og sikkerhetsfaktor for friksjon
fig = plt.figure(figsize=(9, 6))
fig.suptitle('Sensitivitet til totalfriksjon med ulike sidefriksjonsandeler \n i utregning av minste horisontalkurveradius for {} veg'.format(vegklasse), fontsize=20)
fig.subplots_adjust(left=0.09, bottom=0.1, right=0.69, top=0.87, wspace=0.2, hspace=0.367)

ax1 = fig.add_subplot(111)
ax1.scatter(totalfriksjonXverdiP4, minsteHorisontalkurveradiusP4, c='red', zorder=3, label='Krav')
ax1.scatter(totalfriksjonXverdiP2, minsteHorisontalkurveradiusP2, c='red', zorder=3)
ax1.scatter(totalfriksjonXverdiN0, minsteHorisontalkurveradiusN0, c='red', zorder=3)
ax1.scatter(totalfriksjonXverdiM2, minsteHorisontalkurveradiusM2, c='red', zorder=3)
ax1.scatter(totalfriksjonXverdiM4, minsteHorisontalkurveradiusM4, c='red', zorder=3)

ax1.scatter(0.15, minsteHorisontalkurveradiusP4_015, c='cyan', zorder=3, label='Rim')
ax1.scatter(0.15, minsteHorisontalkurveradiusP2_015, c='cyan', zorder=3)
ax1.scatter(0.15, minsteHorisontalkurveradiusN0_015, c='cyan', zorder=3)
ax1.scatter(0.15, minsteHorisontalkurveradiusM2_015, c='cyan', zorder=3)
ax1.scatter(0.15, minsteHorisontalkurveradiusM4_015, c='cyan', zorder=3)

ax1.scatter(0.18, minsteHorisontalkurveradiusP4_018, c='lime', zorder=3, label='Klasse C')
ax1.scatter(0.18, minsteHorisontalkurveradiusP2_018, c='lime', zorder=3)
ax1.scatter(0.18, minsteHorisontalkurveradiusN0_018, c='lime', zorder=3)
ax1.scatter(0.18, minsteHorisontalkurveradiusM2_018, c='lime', zorder=3)
ax1.scatter(0.18, minsteHorisontalkurveradiusM4_018, c='lime', zorder=3)

ax1.scatter(0.20, minsteHorisontalkurveradiusP4_020, c='green', zorder=3, label='Alle klasser')
ax1.scatter(0.20, minsteHorisontalkurveradiusP2_020, c='green', zorder=3)
ax1.scatter(0.20, minsteHorisontalkurveradiusN0_020, c='green', zorder=3)
ax1.scatter(0.20, minsteHorisontalkurveradiusM2_020, c='green', zorder=3)
ax1.scatter(0.20, minsteHorisontalkurveradiusM4_020, c='green', zorder=3)

ax1.scatter(0.23, minsteHorisontalkurveradiusP4_023, c='salmon', zorder=3, label='Klasse B, middels')
ax1.scatter(0.23, minsteHorisontalkurveradiusP2_023, c='salmon', zorder=3)
ax1.scatter(0.23, minsteHorisontalkurveradiusN0_023, c='salmon', zorder=3)
ax1.scatter(0.23, minsteHorisontalkurveradiusM2_023, c='salmon', zorder=3)
ax1.scatter(0.23, minsteHorisontalkurveradiusM4_023, c='salmon', zorder=3)

ax1.scatter(0.30, minsteHorisontalkurveradiusP4_030, c='brown', zorder=3, label='Klasse A')
ax1.scatter(0.30, minsteHorisontalkurveradiusP2_030, c='brown', zorder=3)
ax1.scatter(0.30, minsteHorisontalkurveradiusN0_030, c='brown', zorder=3)
ax1.scatter(0.30, minsteHorisontalkurveradiusM2_030, c='brown', zorder=3)
ax1.scatter(0.30, minsteHorisontalkurveradiusM4_030, c='brown', zorder=3)

ax1.plot(totalfriksjonXverdier, totalfriksjonYverdierM4, zorder=2, c='darkred', label='-4%')
ax1.plot(totalfriksjonXverdier, totalfriksjonYverdierM2, zorder=2, c='c', label='-2%')
ax1.plot(totalfriksjonXverdier, totalfriksjonYverdierN0, zorder=2, c='blue', label='34%')
ax1.plot(totalfriksjonXverdier, totalfriksjonYverdierP2, zorder=2, c='gold', label='+2%')
ax1.plot(totalfriksjonXverdier, totalfriksjonYverdierP4, zorder=2, c='orange', label='+4%')

ax1.set_ylabel('Horisontalkurveradius [m]', fontsize=15)
ax1.set_xlabel('Totalfriksjon', fontsize=15)
ax1.xaxis.set_major_locator(ticker.MultipleLocator(0.04))
ax1.xaxis.set_minor_locator(ticker.MultipleLocator(0.02))
ax1.yaxis.set_major_locator(ticker.MultipleLocator(50))
ax1.yaxis.set_minor_locator(ticker.MultipleLocator(25))
ax1.set_xlim([0, 0.5])
ax1.set_ylim([200, 500])
ax1.grid()
ax1.xaxis.grid(True, which='minor')
ax1.yaxis.grid(True, which='minor')
fig.legend(loc=5, ncol=1, fontsize=15)

# Sidefriksjon
fig = plt.figure(figsize=(9, 6))
fig.suptitle('Sensitivitet til sidefriksjon i utregning av \n minste horisontalkurveradius for {} veg'.format(vegklasse), fontsize=20)
fig.subplots_adjust(left=0.1, bottom=0.1, right=0.75, top=0.85, wspace=0.2, hspace=0.367)

ax2 = fig.add_subplot(111)
ax2.plot(sidefriksjonXverdier, sidefriksjonYverdier, c='blue', label='Standard')
ax2.plot(sidefriksjonXverdier, sidefriksjonYverdier50, c='purple', label='50% økning')
for i in range(len(sidefriksjonerLandUnike)):
    ax2.scatter(sidefriksjonerLandUnike[i], horisontalkurveradiuserLandUnike[i], zorder=5, c=fargerUnike[i], label=landNavnUnike[i])
    ax2.scatter(sidefriksjonerLandUnike[i], horisontalkurveradiuserLandUnike50[i], zorder=5, c=fargerUnike[i])
for i in range(len(sidefriksjonerLandDuplikat)):
    ax2.scatter(sidefriksjonerLandDuplikat[i], horisontalkurveradiuserLandDuplikat[i], zorder=4, c=fargerDuplikat[i], label=landNavnDuplikat[i], s=2 ** 7)
    ax2.scatter(sidefriksjonerLandDuplikat[i], horisontalkurveradiuserLandDuplikat50[i], zorder=4, c=fargerDuplikat[i], s=2 ** 7)
ax2.scatter(sidefriksjonMontana, horisontalkurveradiusMontana, zorder=3, marker='D', c='grey',  s=2 ** 8, label='Montana')
ax2.scatter(sidefriksjonMontana, horisontalkurveradiusMontana50, zorder=3, marker='D', c='grey',  s=2 ** 8)
ax2.set_ylabel('Horisontalkurveradius [m]', fontsize=15)
ax2.set_xlabel('Sidefriksjon', fontsize=15)
ax2.set_xlim([min(sidefriksjonerLand)-0.01, max(sidefriksjonerLand)+0.01])
ax2.set_ylim([nedrunding(min(horisontalkurveradiuserLandUnike)), opprunding(max(horisontalkurveradiuserLandUnike50))])
ax2.yaxis.set_major_locator(ticker.MultipleLocator(25))
ax2.grid()
fig.legend(loc=5, fontsize=15)

# Overhøyde
fig = plt.figure(figsize=(8, 6))
fig.suptitle('Vedlikeholdskrav til overhøyde for \n minste horisontalkurveradius for {} veg'.format(vegklasse), fontsize=20)
fig.subplots_adjust(left=0.1, bottom=0.2, right=0.9, top=0.85, wspace=0.2, hspace=0.367)

ax3 = fig.add_subplot(111)
ax3.plot(overhoydeXverdier, overhoydeYverdier, c='blue', label='Standard', zorder=2)
ax3.plot(overhoydeXverdier, overhoydeYverdier50, c='purple', label='50% Økning', zorder=2)
ax3.scatter(overhoyde, overhoydeYverdiDimensjonerende, c='red', zorder=3)
ax3.scatter(overhoyde, overhoydeYverdiDimensjonerende50, c='green', zorder=3)
ax3.plot([6.5, 6.5], [0, 250], color='black')  # Definerer linjene til vedlikeholdsgrensene
ax3.plot([1.5, 6.5], [1000, 250], color='black')
ax3.plot([9.5, 9.5], [0, 250], c='black')
ax3.plot([4.5, 9.5], [1500, 250], c='black')
ax3.fill_between([1.5, 6.5], [1000, 250], color='lightgrey')  # Gjør verdiene utenfor vedlikeholdsgrensene grå
ax3.fill_between([-3, 1.5], [1000, 1000], color='lightgrey')
ax3.fill_between([4.5, 9.5], [1500, 1500], [1500, 250], color='lightgrey')
ax3.fill_between([9.5, 12], [1500, 1500], color='lightgrey')
ax3.plot(overhoydeGrenseX, overhoydeGrenseY, c='red')  # Lager linjer fra punktene til vedlikeholdsgrensene
ax3.plot(overhoydeLinjeX, overhoydeLinjeY, c='red')
ax3.plot(overhoydeGrenseX50, overhoydeGrenseY50, c='green')
ax3.plot(overhoydeLinjeX50, overhoydeLinjeY50, c='green')
ax3.text(1.5, 375, 'For lite\noverhøyde', zorder=10, fontsize=15)
ax3.text(9.5, 375, 'For mye\noverhøyde', zorder=10, fontsize=15)

ax3.set_ylabel('Horisontalkurveradius [m]', fontsize=15)
ax3.set_xlabel('Overhøyde [%]', fontsize=15)
ax3.tick_params(right=True, left=True, bottom=True)
tick_spacing3_1 = 1
tick_spacing3_2 = 25
ax3.xaxis.set_major_locator(ticker.MultipleLocator(tick_spacing3_1))
ax3.yaxis.set_major_locator(ticker.MultipleLocator(tick_spacing3_2))
ax3.set_xlim([0, 12])
ax3.set_ylim([200, 500])
fig.legend(loc=8, ncol=3, fontsize=15)

fig = plt.figure(figsize=(12, 6))
fig.suptitle('Sensitivitet til overhøydens krav til friksjon for {} veg'.format(vegklasse), fontsize=20)
fig.subplots_adjust(left=0.075, bottom=0.18, right=0.975, top=0.85, wspace=0.25, hspace=0.367)

ax4_1 = fig.add_subplot(121)
ax4_1.plot(sidefriksjonBehovXverdier, sidefriksjonBehovYverdier, c='blue', label='Standard', zorder=2)
ax4_1.plot(sidefriksjonBehovXverdier, sidefriksjonBehovYverdier50, c='purple', label='50% Økning', zorder=2)
ax4_1.scatter(8, sidefriksjonBehov, c='red', zorder=3, s=2 ** 7, label='Standard')
ax4_1.scatter(8, sidefriksjonBehov50, c='red', s=2 ** 7, zorder=3)
ax4_1.scatter(6.5, sidefriksjonBehovDrift, c='salmon', s=2 ** 7, zorder=3, label='Vedlikeholdskrav')
ax4_1.scatter(beregnetOverhoyde, sidefriksjonBehovDrift50, c='salmon', s=2 ** 7, zorder=3)
ax4_1.scatter(6.5-erfaringsverdiOverhoydeAvvik, sidefriksjonBehovErfaring, c='seagreen', s=2 ** 7, zorder=3, label='Erfaring')
ax4_1.scatter(beregnetOverhoyde-erfaringsverdiOverhoydeAvvik, sidefriksjonBehovErfaring50, c='seagreen', s=2 ** 7, zorder=3)

ax4_1.set_title('Sidefriksjon', fontsize=17)
ax4_1.set_ylabel('Sidefriksjonsverdi', fontsize=15)
ax4_1.set_xlabel('Overhøyde [%]', fontsize=15)
ax4_1.set_xlim([0, 9])
ax4_1.grid()

ax4_2 = fig.add_subplot(122)
ax4_2.plot(totalfriksjonBehovXverdier, totalfriksjonBehovYverdier, c='blue', zorder=2)
ax4_2.plot(totalfriksjonBehovXverdier, totalfriksjonBehovYverdier50, c='purple', zorder=2)
ax4_2.scatter(8, totalfriksjonBehov, c='red', s=2 ** 7, zorder=3)
ax4_2.scatter(8, totalfriksjonBehov50, c='red', s=2 ** 7, zorder=3)
ax4_2.scatter(6.5, totalfriksjonBehovDrift, c='salmon', s=2 ** 7, zorder=3)
ax4_2.scatter(beregnetOverhoyde, totalfriksjonBehovDrift50, c='salmon', s=2 ** 7, zorder=3)
ax4_2.scatter(6.5-erfaringsverdiOverhoydeAvvik, totalfriksjonBehovErfaring, c='seagreen', s=2 ** 7, zorder=3)
ax4_2.scatter(beregnetOverhoyde-erfaringsverdiOverhoydeAvvik, totalfriksjonBehovErfaring50, c='seagreen', s=2 ** 7, zorder=3)

ax4_2.set_title('Totalfriksjon', fontsize=17)
ax4_2.set_ylabel('Totalfriksjonsverdi', fontsize=15)
ax4_2.set_xlabel('Overhøyde [%]', fontsize=15)
ax4_2.set_xlim([0, 9])
ax4_2.grid()

fig.legend(loc=8, ncol=5, fontsize=15)

# Sikkerhetsfaktor
fig = plt.figure(figsize=(9, 12))
fig.suptitle('Sensitivitet til sikkerhetsfaktor for friksjon for {} veg'.format(vegklasse), fontsize=20)
fig.subplots_adjust(left=0.09, bottom=0.114, right=0.97, top=0.914, wspace=0.3, hspace=0.27)

ax5 = fig.add_subplot(211)
ax5.set_title('5-persentilverdier for ulike vinterdriftsklasser', fontsize=17)
ax5.plot(sikkerhetsfaktorXverdier, sikkerhetsfaktorYverdier, c='blue', label='Standard')
ax5.plot(sikkerhetsfaktorXverdier, sikkerhetsfaktorYverdier50, c='purple', label='50% Økning')
for i in range(6):
    ax5.scatter(sikkerhetsfaktorerBeregnet5persentil[i], totalfriksjonsverdier5persentil[i], c=totalfriksjonsfarger[i], zorder=5, s=2 ** 6, label=totalfriksjonsnavn[i])
    ax5.scatter(sikkerhetsfaktorerBeregnet5persentil50[i], totalfriksjonsverdier5persentil[i], c=totalfriksjonsfarger[i], zorder=5, s=2 ** 6)
ax5.set_ylabel('Totalfriksjonsverdi', fontsize=15)
ax5.set_xlabel('Sikkerhetsfaktor for friksjon', fontsize=15)
ax5.tick_params(right=True, left=True, bottom=True)
tick_spacing5_1 = 0.2
tick_spacing5_2 = 0.1
tick_spacing5_3 = 0.05
ax5.xaxis.set_major_locator(ticker.MultipleLocator(tick_spacing5_1))
ax5.xaxis.set_minor_locator(ticker.MultipleLocator(tick_spacing5_2))
ax5.yaxis.set_major_locator(ticker.MultipleLocator(tick_spacing5_3))
ax5.set_xlim([0.9, 3.8])
ax5.set_ylim([0, 0.55])
ax5.grid()
ax5.xaxis.grid(True, which='minor')

ax6 = fig.add_subplot(212)
ax6.set_title('15-persentilverdier for ulike vinterdriftsklasser', fontsize=17)
ax6.plot(sikkerhetsfaktorXverdier_15, sikkerhetsfaktorYverdier_15, c='orange', label='Standard 2014')
ax6.plot(sikkerhetsfaktorXverdier_15, sikkerhetsfaktorYverdier_15_50, c='olive', label='50 % økning 2014')
for i in range(6):
    ax6.scatter(sikkerhetsfaktorerBeregnet15persentil[i], totalfriksjonsverdier15persentil[i], c=totalfriksjonsfarger[i], zorder=5, s=2 ** 6)
    ax6.scatter(sikkerhetsfaktorerBeregnet15persentil_50[i], totalfriksjonsverdier15persentil[i], c=totalfriksjonsfarger[i], zorder=5, s=2 ** 6)
ax6.set_ylabel('Totalfriksjonsverdi', fontsize=15)
ax6.set_xlabel('Sikkerhetsfaktor for friksjon', fontsize=15)
ax6.tick_params(right=True, left=True, bottom=True)
tick_spacing5_1 = 0.2
tick_spacing5_2 = 0.1
tick_spacing5_3 = 0.05
ax6.xaxis.set_major_locator(ticker.MultipleLocator(tick_spacing5_1))
ax6.xaxis.set_minor_locator(ticker.MultipleLocator(tick_spacing5_2))
ax6.yaxis.set_major_locator(ticker.MultipleLocator(tick_spacing5_3))
ax6.set_xlim([0.9, 3.8])
ax6.set_ylim([0, 0.55])
ax6.grid()
ax6.xaxis.grid(True, which='minor')
fig.legend(loc=8, ncol=5, fontsize=13, mode='expand')

plt.show()
