# Skriv inn stien som leder til der mappen 'Programmering' er lagret
# Eks: 'C:\\Bruker\\Dokumenter\\Programmerg\\
sti = 'C:\\Programmering\\'

import sys

# Definerer søkestier som funksjoner skal hentes fra
NVDB_bibliotek= sti+'QGIS/nvdbapi-V3-master/'
kodeSti = sti+'QGIS/Custom'
if not [k for k in sys.path if 'nvdbapi-V3' in k]:
    sys.path.append(NVDB_bibliotek)
if not [k for k in sys.path if 'Custom' in k]:
    sys.path.append(kodeSti)

# Importerer funksjonene som skal brukes
from Hjelpefunksjoner import FinnFiler, FilInformasjon, LeggTilMaalinger, LeggTilBru, TestBruEksistens, LeggTilDriftsklasse, LeggTilKurvatur, LagBuffer, ArvNVDB_Bru, ArvNVDB_Annet, FerdigFil, Nullstill

# Lager en vektor med filnavnene som skal behandles
samlingFilnavn = FinnFiler(sti)

# Starter løkken som behandler én fil om gangen
for fil in samlingFilnavn:
    
    # Leser filens verdi for dato, system, fylke, vegreferanse og distanse
    metaData = FilInformasjon(fil)
    # Definerer variablene som brukes i funksjonene
    metaDataLinjer = metaData[0]
    filnavn = metaData[1]
    veg = metaData[2]

    # Importerer friksjonsmålingene til QGIS og lager et område som dekker alle målepunktene
    kartutsnitt = LeggTilMaalinger(fil)
    
    # Henter bruer fra NVDB og legger dem til i listen over lag
    LeggTilBru(veg, kartutsnitt)

    # Behandler kun filer hvor det måles friksjon på bru
    bruTest = TestBruEksistens()
    if bruTest == 1:

        # Legger til driftsklassene
        LeggTilDriftsklasse(veg, kartutsnitt)
        # Legger til kurvatur
        LeggTilKurvatur(veg, kartutsnitt)
        # Lager buffer rundt bru, driftsklasse og kurvatur
        LagBuffer()
        # Knytter friksjonsmålingene til brudata fra NVDB og beregner avstander
        ArvNVDB_Bru()
        # Legger til ytterligere informasjon angående driftsklasse og radius fra NVDB
        ArvNVDB_Annet()
        # Skriver den nye informasjonen til en DAT-fil
        FerdigFil(sti, filnavn, metaDataLinjer)

    # Nullstiller arbeidsområdet for å klargjøre nye kjøringer
    Nullstill()
print('Behandlet {} filer'.format(len(samlingFilnavn)))